\name{mvnPlot}
\alias{mvnPlot}

\title{
Perspective and Contour Plots
}
\description{
This function creates perspective and contour plots for a bivariate data set.
}
\usage{
mvnPlot(object, type = c("persp", "contour"), default = TRUE, ...)
}

\arguments{
  \item{object}{
an object of \code{mardia}, \code{hz} or \code{royston} class
}
  \item{type}{
if type is selected as \code{persp} it creates a perspective plot, if type is selected as \code{contour} it creates a contour plot.
}
  \item{default}{
when \code{default} is \code{TRUE} it creates plots in default settings
}
  \item{\dots}{
an optional argument
}
}

\details{
After set the \code{default=FALSE} option, users can define their own plot settings with changing \code{theta}, \code{phi}, \code{border} and \code{shade}. 	
}	

\author{
Selcuk Korkmaz <\email{selcuk.korkmaz@hacettepe.edu.tr}> and Dincer Goksuluk <\email{dincer.goksuluk@hacettepe.edu.tr}>
}
\note{
Please be careful that this function creates perspective and contour plots when there are only two variables.
}


\seealso{
\code{\link[MVN]{roystonTest}} \code{\link[MVN]{hzTest}} \code{\link[MVN]{mardiaTest}}
}
\examples{
Iris = iris[1:50, 1:2] # Iris data only for setosa and two variables
result = hzTest(Iris)
### Perspective Plot ### 
mvnPlot(result, type = "persp", default = TRUE)
### Contour Plot ### 
mvnPlot(result, type = "contour", default = TRUE)
}
